/**
 * Array operations types
 */
export declare enum ARRAY_OPERATION {
    ADD = "ADD",
    EDIT_AT = "EDIT_AT",
    EDIT_PROP_AT = "EDIT_PROP_AT",
    REMOVE_AT = "REMOVE_AT",
    MOVE_UP = "MOVE_UP",
    MOVE_DOWN = "MOVE_DOWN"
}
/**
 * Options type
 */
export declare type ArrayHandlerOptType<T, K extends keyof T> = {
    operation: ARRAY_OPERATION.ADD;
    newValue: T;
} | {
    operation: ARRAY_OPERATION.EDIT_AT;
    newValue: T;
    index: number;
} | {
    operation: ARRAY_OPERATION.REMOVE_AT | ARRAY_OPERATION.MOVE_DOWN | ARRAY_OPERATION.MOVE_UP;
    index: number;
} | {
    operation: ARRAY_OPERATION.EDIT_PROP_AT;
    index: number;
    key: K;
    propValue: T[K];
};
/**
 * Array handler type
 */
declare type changeHandlerType<T, K extends keyof T> = (args: {
    newArray: T[];
    oldArray: T[];
    opt: ArrayHandlerOptType<T, K>;
}) => T[];
declare function arrayHandler<T, K extends keyof T>(array: T[], opt: ArrayHandlerOptType<T, K>, changeHandler?: changeHandlerType<T, K>): T[];
export default arrayHandler;
